
/*
 *      file    name            charproc.c
 *      (C) Copyright           Akito Monden    1996 - 1998
 */

/*
   $B$3$N%U%!%$%k$G$O!"(B
   $B%H%i%C%/$+$i#1J8;z<h$C$F$/$k=hM}!"$*$h$S!"%^%/%m$N=hM}$r9T$&!#(B
   */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "win.h"
#include "file.h"
#include "charproc.h"

extern void err(int i); /* mml2mid.c $B$K$"$k(B */

#ifdef BCC
extern long fp2;         /* $B=PNO%U%!%$%k(B(mid) */
extern void write_length(long i, long fp);
#else
extern file *fp2;         /* $B=PNO%U%!%$%k(B(mid) */
extern void write_length(long i, file *fp);
#endif

#ifdef BCC
extern long fp1;
#else
extern file *fp1;
#endif

extern void remove_file(void); /* 1997.10.19$BDI2C(B */

extern int cur_line;           /* $B8=:_$N(BMML$B%=!<%9>e$N9THV9f(B */
extern int tnum; /* $B%H%i%C%/$rI=$9(B 0A 1B 2C $B$J$I$N(B 0,1,2 */
extern int talf; /* $B%H%i%C%/$rI=$9(B 0A 1B 2C $B$J$I$N(B A,B,C */
extern int kloop_ptr;          /* $B%k!<%W%M%9%H?t(B */
/* --- $B0J2<#59T#M#K#R$NDI2C(B */
extern fpos_t lastlenpos; /* $B:G8e$K2;D9$r=q$-9~$s$@>l=j$X$N%]%$%s%?(B */
extern long lastlen;      /* $B:G8e$K=q$-9~$s$@2;D9$NCM(B */
extern long tstep;
extern long master_step[512];	/* MKR$BDI2C(B */
extern int master_count;		/* MKR$BDI2C(B */
extern long master_step_temp;

extern int head; /* $B=>B0%Q!<%H$K%X%C%@$r=q$$$?$+$I$&$+$N%U%i%0(B */
extern void write_header(void);

int cur_macro;          /* $B8=:_FI$_9~$_Cf$N%^%/%m(B */
int cur_macronum;       /* $B%^%/%m$N8=:_FI$_9~$_Cf$NJ8;z(B */
/* int macros[26][MAXMACROSTR]; */ /* $B%^%/%mJ]B8MQ(B */
char **macros; /* $B%^%/%mJ]B8MQ(B */

int nexttrack(void);
void macroloop(char *a, char *b);
int macro(int x);
int track(void);
long gettrack(void);
#ifndef BCC
int skipts(void);
int getnum(void);
#else
extern int skipts(void);
extern int getnum(void);
#endif

void freemacro(void)
{
    int i;
    for(i = 0; i < 260; i ++){
	if(macros[i] != (char *)'\0') free(macros[i]);
    }
    free(macros);
}

/*
   $B%^%/%m$r=i4|2=$9$k!#(B
   */
void initmacro(void)
{
    int i;
	
    macros = (char **)malloc(sizeof(char *) * 10 * 26);
    for(i = 0; i < 260; i ++){
	macros[i] = (char *)'\0';
    }
}

/* $B%^%/%mFb$N%k!<%W$rE83+$9$k(B */
void macroloop(char *a, char *b)
{
    int i, k = 0;
    int count;
    int mloop[MAXMACROSTR];
    int mloop_c[MAXMACROSTR];
    int mloop_ptr = 0;
    int x, xx;
    for(i = 0;;){
	if(i >= MAXMACROSTR - 1){
	    err(43);		/* $B%^%/%mD9$9$.(B */
	}
	xx = a[i++];
	switch(xx){
	case '[':
	    mloop[mloop_ptr] = i; /* $B%k!<%W3+;OCOE@$N%;%C%H(B */
	    mloop_c[mloop_ptr] = -1; /* $B%k!<%W$r2s$k2s?t(B.$B:G=i$O(B-1$B$K$7$F$*$/(B */
	    mloop_ptr++;
	    break;
	case '/':
	case ':':		/* $B%k!<%W%"%&%H(B */
	    if(mloop_c[mloop_ptr - 1] == 1){
		if(xx == '/'){
		    wsprintf(Msg, "Warning: loop out '/' in macro is obsolete. Please use ':' instead.\n");
		    strcat(text,Msg);
		}
		count = 0;
		for(;;){
		    x = a[i++];
		    if(i >= MAXMACROSTR - 1) err(47); /* :$B$N>l=j$,JQ(B */
		    if(x == '[') count++;
		    else if(x == ']'){
			for(;;){ /* $B?tCM$rHt$P$9(B */
			    x = a[i++];
			    if(x < '0' || '9' < x){
				i--;
				break;
			    }
			}
			if(count == 0) break;
			count--;
		    }else if(x == 0){
			err(48); /* ]$B$,$J$$(B */
		    }
		}
		mloop_ptr--;	/* $B%k!<%W$rH4$1$?$N$G!"%M%9%H?t$r8:$i$9(B */
	    }
	    break;
	case ']':		/* $B7+$jJV$7$N=*$o$j!#(B */
	    if(mloop_ptr == 0) err(49); /* $B%^%/%mFb$N%k!<%W$,JQ(B */
	    count = 0;
	    for(;;){
		x = a[i++];
		if(x < '0' || '9' < x){
		    i--;
		    break;
		}
		count = count * 10 + x - '0';
	    }
	    if(count == 0) count = 2;
	    if(count == 1) err(37);
	    if(mloop_c[mloop_ptr - 1] == -1){ /* $B$^$@%k!<%W$r2s$C$F$J$$>l9g(B */
		mloop_c[mloop_ptr - 1] = count - 1;
		/* $B%k!<%W$r2s$k;D$j$N2s?t$r%;%C%H(B */
    	    }else{
    	        mloop_c[mloop_ptr - 1]--;
    	        if(mloop_c[mloop_ptr - 1] == 0){
    	            mloop_ptr--;
    	            break;
    	        }
    	    }
    	    i = mloop[mloop_ptr - 1]; /* $B%k!<%W$N@hF,$KHt$V(B */
	    break;
	case '\0':
	    b[k] = xx;
	    goto sss;
	default:
	    b[k] = xx;
	    k++;
            if(k >= MAXMACROSTR - 1){
		err(43);	/* $B%^%/%m$,D9$9$.$k(B */
            }
	    break;
	}
    }
 sss:
    return;
}

/*
   $B%^%/%m$rJ]B8$9$k!#(B
   */
void getmacro(void)
{
    int i, code, j;
    int cm;			/* $B=hM}Cf$N%^%/%m(B */
    char *mcr = (char *)alloca(MAXMACROSTR);
    char *mcr2 = (char *)alloca(MAXMACROSTR);
    for(;;){
        code = getc2(fp1);
        if(code == EOF) break;
        if(code == '\n'){
            code = getc2(fp1);
            if(code == EOF) break;
            if(code == '$'){
                code = getc2(fp1);
                cm = 0;
                if('0' <= code && code <= '9'){
		    cm = (code - '0') * 10;
		    code = getc2(fp1);
                }
                if(code < 'a' || 'z' < code) err(5);
                cm += code - 'a';
                if(macros[cm] != (char *)'\0'){
		    /* $B#2=EDj5A$r5v$9$3$H$K$9$k(B */
		    /* err(46); */ /* $B#2=EDj5A(B */
		}else{
		    macros[cm] = (char *)malloc(sizeof(char) * MAXMACROSTR);
		}
                
                /* $B$H$j$"$($:%^%/%m$r(B mcr[...]$B$KF~$l$k(B */
                for(i = 0;;i++){
		    if(i >= MAXMACROSTR -1) err(43); /* $B%^%/%mD9$9$.(B */
		    code = getc2(fp1);
                    if(code == 0x0d || code == '\n' || code == EOF || code == ';') break;
                    mcr[i] = code;
                }
                mcr[i] = '\0';
                
                /* $B%^%/%mFb$N%k!<%W$rE83+$9$k(B */
                macroloop(mcr, mcr2);
                j = 0;
                for(i = 0;;i++){
		    if(i >= MAXMACROSTR -1) err(43); /* $B%^%/%mD9$9$.(B */
                    code = mcr2[j++];
                    if(code == '\0') break;
                    if(code == '$'){
                    	int cm2 = 0;
			code = mcr2[j++];
			if('0' <= code && code <= '9'){
			    cm2 = (code - '0') * 10;
			    code = mcr2[j++];
			}
			if(code < 'a' || 'z' < code){
			    err(44);
			}
			cm2 += code - 'a';
                    	if(macros[cm2] == (char *)'\0'){
			    err(45); /* $BL$Dj5A%^%/%m$r8F$s$@(B */
                    	}
                    	if(strlen(macros[cm2]) + i >= MAXMACROSTR - 1) err(43);
                    	macros[cm][i] = '\0';
                    	strcat(macros[cm], macros[cm2]);
                    	i += strlen(macros[cm2]) - 1; /* continue$B$G(Bi++$B$5$l$k$N$G(B $B!J2>$K(B1$BJ8;z(Bstrcat$B$9$k>l9g$O(Bi$B$O(B0$BB-$;$P$h$$!K(B */
                    	continue;
                    }
                    macros[cm][i] = code;
                }
                macros[cm][i] = '\0'; /* $B%^%/%mJ8;zNs$N=*C<%3!<%I$O(BNULL */
                /* printf("macro number %d = '%s'\n", cm, macros[cm]); */
                if(code == EOF) break;
                else{ fseek2(fp1, -1, SEEK_CUR); } /* $B$3$l$,$J$$$H%@%a(B */
            }else if(code == '/'){
                code = getc2(fp1);
                if(code == '*'){ /* $B%3%a%s%H=hM}(B */
                    for(;;){
                        code = getc2(fp1);
                        if(code == EOF) break;
                        if(code == '*'){
                            code = getc2(fp1);
                            if(code == '/') break;
                        }
                    }
                    if(code == EOF) break;
                }else{
                    fseek2(fp1, -1, SEEK_CUR);
                }
            }else{
                fseek2(fp1, -1, SEEK_CUR);
            }
        }
    }
}

/*
   tnum, talf$B$KBP1~$9$k%H%i%C%/$+$i(B1$BJ8;z<h$C$F$/$k!%(B
   $B<h$C$F$3$l$J$$>l9g(B($B%H%i%C%/$N:G8e$KMh$?>l9g(B)$B$O(B -1 $B$rJV$9!%(B
   $B%9%Z!<%9!"%?%V!"(B!$B!"(B; $B$J$I$N=hM}$b$3$3$G$d$k!#(B
   $B%^%/%m$N=hM}$b$3$3$G$d$k!#(B
   
   x == 0 $B#1J8;z<h$C$?8e$K%]%$%s%?0\F0!#(B
   x == 1 $B#1J8;z<h$C$?8e$K%]%$%s%?$O0\F0$7$J$$!#(B
   x == 2 $B%]%$%s%?0\F0$@$1!#$?$@$7!"D>A0$G(Bgetbyte(1)$B$,8F$P$l$F$$$kI,MW$,$"$k!#(B
   */
int getbyte(int x)
{
    static int f = 0;		/* $B<!$N9T$rD4$Y$K9T$/$+$I$&$+$N%U%i%0(B */
    int i, code;		/* $BHFMQ(B */
    
    if(x == -1){f = 0; return 0;}
    
    for(;;){
	switch(f){
	case 0:			/* $B<!$N%H%i%C%/$N@hF,$K0\F0$9$k>l9g(B */
	    i = nexttrack();
	    if(i == -1) return -1;
	    f = 1;		/* $B$3$ND>8e$N(Bbreak;$B$r>JN,$7$F$$$k(B */
	case 1:			/* $B%H%i%C%/$NCf$+$i#1J8;z<h$C$F$/$k>l9g(B */
	    if(x == 2){
		fseek2(fp1, 1, SEEK_CUR);
		return 0;
	    }
	    code = track();
	    if(code == -1){	/* EOF$B$,$"$C$?(B */
		f = 0;		/* $B<!$N%H%i%C%/L>$N$?$a$K(B f = 0 $B$KLa$7$F$*$/(B */
		return -1;
	    }else if(code == -2){ /* $B9TKv$KMh$?(B */
		f = 0;
		break;
	    }else if(code == -3){ /* $B%^%/%m$KMh$?(B */
		f = 2;
		break;
	    }
	    /* $B%H%i%C%/Fb$+$i#1J8;z<h$C$F$-$?(B */
	    if(x == 0){ /* 1$BJ8;z<h$C$?8e$K%]%$%s%?$r0\F0$7$?$$>l9g(B */
		if (tnum==0) { /* $B<g%H%i%C%/$N>l9g(B */
		    /* $B=>B0%H%i%C%/$N%9%F%C%W9g$o$;(B */
		    for (i=master_count-1;i>=0;i--) {
			if (master_step[i]==-2) {
			    master_step[i]=tstep;
			} else break;
		    }
		} else { /* $B=>B0%H%i%C%/$N>l9g(B */
		    if (master_step_temp>=0) { /* $B=>B0%H%i%C%/$N@hF,(B */
			/*
			   tstep $B$O(B1$B8DA0$N!J!)!K%9%F%C%W(B
			   master_step_temp$B$O!$=>B0%H%i%C%/$N@hF,$N%9%F%C%W(B
			   */
			if (master_step_temp<tstep) {
			    /*printf ("Step %ld->%ld ",tstep,master_step_temp);
			      err(37);*/
			}
			if(head == 0){
			    head = 1;
			    write_header(); /* $B=>B0%H%i%C%/$N%X%C%@$r=q$/(B */
			}
			tstep -= lastlen;
			fsetpos2(fp2, &lastlenpos);
			write_length(master_step_temp-tstep , fp2);
			master_step_temp=-1;
		    }
		}
	    }
	    else if(x == 1) fseek2(fp1, -1, SEEK_CUR);
	    return code;	/* $B%H%i%C%/Fb$+$i#1J8;z<h$C$F$3$l$?(B */
	case 2:			/* $B%^%/%mFb$+$i#1J8;z<h$C$F$/$k>l9g(B */
	    if(x == 2){
		cur_macronum++;
		return 0;
	    }
	    code = macro(x);
	    if(code == -1){	/* $B%^%/%mFb$NJ8;z$,?T$-$?(B */
		f = 1;
		break;
	    }
	    return code;	/* $B%^%/%mFb$+$i#1J8;z<h$C$F$3$l$?(B */
	}
    }
}

/*
   $B<!$N%H%i%C%/$N@hF,$K0\F0$9$k!#(B
   $B<!$N%H%i%C%/$,$J$$>l9g$O!"(B-1$B$rJV$9!#(B
   */
int nexttrack()
{
    long li, lj;
    li=gettrack();
    switch(li){
    case -1:		/* EOF */
	return -1;
    case -2:		/* $BIaDL$N>l9g(B */
	break;
    case -3:		/* $B=>B0%H%i%C%/$KBP1~$9$k<g%H%i%C%/$,$J$$>l9g(B */
	err(36);
    default:			/* $B5"$C$F$-$?%9%F%C%W$KD4@0$7$m(B */
	master_step_temp=li;	/*$B$3$3$G$OJQ?t$K3JG<$9$k$@$1!#(B*/
	break;
    }
#ifndef BCC
    if(skipts() == -1) return -1; /* $BJQ$JJ8;z$,$"$C$?(B */
#endif
    return 0;
}

/*
   $B%^%/%m$+$i(B1$BJ8;z<h$C$F$/$k!#(B
   $B%^%/%mFb$NJ8;z$,?T$-$?$H$-!"(B-1$B$rJV$9!#(B
   */
int macro(int x)
{
    int code;
    for(;;){
	code = macros[cur_macro][cur_macronum];
	if(code == NULL){
	    return -1;
        }
        if(code == '\t' || code == ' ' || code == 0x0d || code == '|'){
            cur_macronum++;
            continue;
        }
        if(x == 0){
            cur_macronum++;
        }
        return code;
    }
}

/*
   $B%H%i%C%/Fb$+$i#1J8;z<h$C$F$/$k!#(B
   $B<h$C$F$3$l$J$$(B(EOF)$B>l9g$O!"(B-1$B$rJV$9!#(B
   $B9TKv$KMh$?>l9g$O!"(B-2$B$rJV$9!#(B
   $B%^%/%m$KF~$C$?>l9g$O!"(B-3$B$rJV$9!#(B
   */
int track(void)
{
    static fpos_t kloop[16];	/* $B%k!<%W3+;O0LCV(B */
    static int kloop_c[16];	/* $B%k!<%W$r2s$C$?2s?t(B */
    static int kloop_l[16];	/* $B%k!<%W3+;OCOE@$N9THV9f(B */
    int i, code, count;		/* $BHFMQ(B */
    for(;;){
	code = getc2(fp1);	/* $B8=:_$N>l=j$+$iFI$s$G$/$k(B */
	switch(code){
	case EOF:
	    /* case '!': */ /* '!'$B0J9_$OA4$FL5;k$9$k(B */
	    return -1;
	case '\n':
	    fseek2(fp1, -1, SEEK_CUR);
	    return -2;
	case 0x0d:		/* 0x0d $B$OL5;k$9$k(B */
	case '\t':		/* $B%?%V$OL5;k$9$k(B */
	case ' ':		/* $B%9%Z!<%9$OL5;k$9$k(B */
	case '|':		/* $B>.@a@~$OL5;k$9$k(B */
	    break;
	case '#':		/* '#'$B$G;O$^$k9T$O%3%a%s%H$H$_$J$9(B */
	case ';':		/* $B%3%a%s%H=hM}(B */
	    for(;;){
		code = getc2(fp1);
		if(code == EOF){
		    return -1;
		}
		if(code == '\n'){
		    fseek2(fp1, -1, SEEK_CUR);
		    return -2;
		}
	    }
	case '[':		/* $B7+$jJV$7$N3+;O(B */
	    fgetpos2(fp1, &kloop[kloop_ptr]); /* $B%k!<%W3+;OCOE@$N%;%C%H(B */
	    kloop_c[kloop_ptr] = -1; /* $B%k!<%W$r2s$k2s?t!#:G=i$O(B-1$B$K$7$F$*$/(B */
	    kloop_l[kloop_ptr] = cur_line; /* $B9THV9f$NJ]B8(B */
	    kloop_ptr++;
	    break;
	case '/':
	case ':':		/* $B%k!<%W%"%&%H(B */
	    if(kloop_c[kloop_ptr - 1] == 1){
		if(code == '/'){
		    wsprintf(Msg, "Warning: loop out '/' in line %d is obsolete. Please use ':' instead.\n", cur_line);
		    strcat(text,Msg);
		}
		count = 0;
		i = cur_line;	/* $B9THV9f$NJ]B8!J%(%i!<$r=P$9$H$-$N$?$a$K!K(B */
		for(;;){
		    code = getc2(fp1);
		    if(code == '[') count++;
		    else if(code == ']'){
			(void)getnum();
			if(count == 0) break;
			count--;
		    }else if(code == ';'){
			for(;;){
			    code = getc2(fp1);
			    if(code == EOF) return -1;
			    else if(code == '\n'){
				fseek2(fp1, -1, SEEK_CUR);
				if(nexttrack() == -1){
				    cur_line = i; /* ':'$B$,$"$C$?9THV9f$KLa$9(B */
				    err(4);
				}
				break;
			    }
			}
		    }else if(code == '\n'){
			fseek2(fp1, -1, SEEK_CUR);
			if(nexttrack() == -1){
			    cur_line = i; /* ':'$B$,$"$C$?9THV9f$KLa$9(B */
			    err(4);
			}
		    }else if(code == EOF){
			cur_line = i; /* ':'$B$,$"$C$?9THV9f$KLa$9(B */
			err(4);
		    }
		}
		kloop_ptr--;	/* $B%k!<%W$rH4$1$?$N$G!"%M%9%H?t$r8:$i$9(B */
	    }
	    break;
	case ']':		/* $B7+$jJV$7$N=*$o$j!#(B */
	    if(kloop_ptr == 0) err(3);
	    count = getnum();
	    if(count == 0) count = 2;
	    if(count == 1) err(37);
	    if(kloop_c[kloop_ptr - 1] == -1){ /* $B$^$@%k!<%W$r2s$C$F$J$$>l9g(B */
		kloop_c[kloop_ptr - 1] = count - 1;
		/* $B%k!<%W$r2s$k;D$j$N2s?t$r%;%C%H(B */
    	    }else{
    	        kloop_c[kloop_ptr - 1]--;
    	        if(kloop_c[kloop_ptr - 1] == 0){
    	            kloop_ptr--;
    	            break;
    	        }
    	    }
	    fsetpos2(fp1, &kloop[kloop_ptr -1]); /* $B%k!<%W$N@hF,$KHt$V(B */
	    cur_line = kloop_l[kloop_ptr - 1]; /* $B9THV9f$rLa$9(B */
	    break;
	case '$':		/* $B%^%/%m(B */
	    code = getc2(fp1);
            cur_macro = 0;
            if('0' <= code && code <= '9'){
               	cur_macro = (code - '0') * 10;
                code = getc2(fp1);
            }
            if(code < 'a' || 'z' < code){
               	err(6);
            }
            cur_macro += code - 'a';
	    cur_macronum = 0;
	    /* if(macros[cur_macro][0] == '\0') */
	    if(macros[cur_macro] == '\0'){
		strcat(text, "ERROR!  ");
		wsprintf(Msg ," No such macro '%c'", code);
		strcat(text,Msg);
		wsprintf(Msg," in line %d.\n", cur_line);
		strcat(text,Msg);
		remove_file();
	    }
	    return -3;
	default:
	    return code;
	}
    }
}



/*
   tnum, talf $B$KBP1~$9$k%H%i%C%/$r(B1$B9T$@$1<h$C$F$/$k!%(B
   $B!J%H%i%C%/$N@hF,$K%]%$%s%?$r0\$9!K(B
   
   0A$B$O(BA$B$HF1$8!%(B?$B$O(BA$B$+$i(BZ$B$N%o%$%k%I%+!<%I!%JBNsI=5-2DG=!%(B
   
   $B%H%i%C%/L>5-=RNc(B:
   A       == 0A
   0A      == 0A
   1A      == 1A
   ?       == 0A - 0Z
   2?      == 2A - 2Z
   1A2B    == 1A, 2B
   0?2?    == 0A - 0Z, 2A - 2Z
   0A1BC2D == 0A, 1B, 0C, 2D
   ABCD1?  == 0A, 0B, 0C, 0D, 1A - 1Z
   
   1BC $B$J$I$H$d$C$F$b!$(B1B, 1C $B$K$O$J$i$J$$E@$KCm0U!%(B(1B,0C$B$K$J$k(B)
   1B,1C$B$r;XDj$7$?$$>l9g$K$O!$(B1B1C$B$H=q$+$J$$$H$$$1$J$$!%(B
   $B9TF,$K6uGr$d%?%V$,$"$C$F$O$$$1$J$$!%(B
   $B%H%i%C%/L>$ND>8e$K$O(B1$B8D0J>e$N6uGr$,$J$$$H$$$1$J$$!%(B
   
   $B%H%i%C%/L>$H8+$J$;$J$$>l9g$O!"L5;k$9$k!%!J%(%i!<$O=P$5$J$$!K(B
   
   $B8=:_$N9THV9f$,>o$K(B cur_line $B$KF~$k!%(B

   */
#ifndef BCC

long gettrack2(void);
int talf2;
int tnum2;
extern char track_map[320];

long gettrack(void)
{
    int code;
    int i1, i2;
    static int scan_flag = 0;
    
    if(talf == 0 && tnum == 0 && scan_flag == 0){ /* $B%H%i%C%/%^%C%W$N:n@.(B */
	scan_flag = 1;
	tnum2 = 0;
	for(talf2 = 0; talf2 < 26; talf2++){
	    int x;
	    x = gettrack2();
	    if(x == -2){
		track_map[talf2] = 1;
	    }
	    fseek2(fp1, 0, SEEK_SET); /* $B%U%!%$%k$N@hF,$K0\F0(B */
	}
    }
    
    for(;;){
        code = getc2(fp1);
        if(code == EOF) return -1;
        if(code == '\n'){
            cur_line++;
            for(;;){
            aho:
                i1 = getc2(fp1);
                if(i1 == '\n'){ cur_line++; continue; }
                i2 = getc2(fp1);
                if(i2 == '\n'){ cur_line++; continue; }
                if(i1 == EOF || i2 == EOF) return -1;
                if(i1 == '/' && i2 == '*'){ /* $B%3%a%s%H=hM}(B */
                    for(;;){
                        i1 = getc2(fp1);
                        if(i1 == '\n') cur_line++;
                        if(i1 == EOF) return -1;
                        if(i1 == '*'){
                            i2 = getc2(fp1);
                            if(i2 == '\n') cur_line++;
                            if(i2 == '/') goto aho;
                        }
                    }
                }
                if(i1 < '0' || 10 + '0' - 1 < i1){ /*0$B!A(B?$B$,>JN,$5$l$F$k>l9g(B*/
                    i2 = i1;
                    i1 = '0';
                    fseek2(fp1, -1, SEEK_CUR);
                }
		if(tnum == 0){ /* $B<g%H%i%C%/8!::(B */
		    if(i1 == '0'){
			if(i2 == talf + 'A' || i2 == '?'){ /* $B<g%H%i%C%/H/8+(B */
			    master_step[master_count++] = -2;
			    master_step[master_count] = -1;
			    return -2;
			}
		    }else if(i2 == talf + 'A' || i2 == '?'){
			/* $B=>B0%H%i%C%/H/8+(B */
			track_map[(i1 - '0') * 32 + talf] = 1;
			/* $B=>B0%H%i%C%/%^%C%W:n@.(B */
		    }
                }else{ /* $B=>B0%H%i%C%/8!::(B */
		    if(i1 == '0'){
			if(i2 == talf + 'A' || i2 == '?'){ /* $B<g%H%i%C%/H/8+(B */
			    master_count++;
			}
		    }else if(i1 - '0' == tnum){
			if(i2 == talf + 'A' || i2 == '?'){
			    /* $B=>B0%H%i%C%/H/8+(B */
			    if(master_count == -1){
				return -3; /* $B<g%H%i%C%/$,$J$$(B */
			    }
			    return master_step[master_count];
			}
		    }
		}
                if('A' <= i2 && i2 <= 'Z') continue;
                if(i2 == '?') continue;
                break;
            }
        }
    }
}

long gettrack2(void)
{
    int code;
    int i1, i2;

    for(;;){
        code = getc2(fp1);
        if(code == EOF) return -1;
        if(code == '\n'){
            cur_line++;
            for(;;){
            aho:
                i1 = getc2(fp1);
                if(i1 == '\n'){ cur_line++; continue; }
                i2 = getc2(fp1);
                if(i2 == '\n'){ cur_line++; continue; }
                if(i1 == EOF || i2 == EOF) return -1;
                if(i1 == '/' && i2 == '*'){ /* $B%3%a%s%H=hM}(B */
                    for(;;){
                        i1 = getc2(fp1);
                        if(i1 == '\n') cur_line++;
                        if(i1 == EOF) return -1;
                        if(i1 == '*'){
                            i2 = getc2(fp1);
                            if(i2 == '\n') cur_line++;
                            if(i2 == '/') goto aho;
                        }
                    }
                }
                if(i1 < '0' || 10 + '0' - 1 < i1){ /*0$B!A(B?$B$,>JN,$5$l$F$k>l9g(B*/
                    i2 = i1;
                    i1 = '0';
                    fseek2(fp1, -1, SEEK_CUR);
                }
                if(i1 == tnum2 + '0'){
                    if(i2 == talf2 + 'A') return -2;
                    if(i2 == '?') return -2;
                }
                if('A' <= i2 && i2 <= 'Z') continue;
                if(i2 == '?') continue;
                break;
            }
        }
    }
}
#endif

/*
   $B%H%i%C%/$N:G=i$N%9%Z!<%9$+%?%V$+>.@a@~$^$G0\F0$9$k!%(B
   $B%9%Z!<%9$^$G$KJQ$JJ8;z$,$"$C$?$i!$(B -1 $B$rJV$9!%(B
   */
#ifndef BCC
int skipts(void)
{
    int code;
    for(;;){
        code = getc2(fp1);
        if(code == EOF) return -1;
        if(code == '\n'){
            fseek2(fp1, -1, SEEK_CUR);
            return -1;
        }
        if(code == ' ' || code == '\t' || code == '|') return 0;
        if('A' <= code && code <= 'Z') continue;
        if('0' <= code && code < 10 + '0') continue;
        if(code == '?') continue;
        return -1;
    }
}
#endif

/*
   $B?tCM$N<hF@(B
   */
int getnum(void)
{
    int num = 0;
    int code;
    for(;;){
        code = getc2(fp1);
        if(code < '0' || '9' < code){
            fseek2(fp1, -1, SEEK_CUR);
            break;
        }
        num = num * 10 + code - '0';
    }
    return num;
}

