
/*
 *      Program name            MML->MID Compiler  Version 5.07
 *      Program written         A.Monden        1996/11/11
 *      Program modified        A.Monden        1998/2/6
 *                              H.Fujii (MKR)   1996/11/24
 *      (C) Copyright           Akito Monden    1996 - 1998
 *                              Hideki Fujii    1996
 */

/*
 *      file    name            mml2mid.c
 *      (C) Copyright           Akito Monden    1996 - 1998
 */

#define GLOBAL_VALUE_DEFINE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include "win.h"
#include "file.h"
#include "charproc.h"
#include "mmlproc.h"
#include "mml2mid.h"

#ifdef BCC
#include <alloc.h> /* include if TC or BC */
#include <fcntl.h> /* for O_BINARY */
#endif

#ifdef GCC
#include <fcntl.h> /* for O_BINARY */
#endif

#define MAXTITLESTR 256

jmp_buf env; /* $B%(%i!<=hM}MQ(B */
#ifdef BCC
long fp1;	/* $BF~NO%U%!%$%k(B(mml) */
long fp2;	/* $B%F%s%]%^%C%W0J30$N(BSMF$B$r=q$-9~$`>l=j(B */
long fp3;	/* $B=PNO%U%!%$%k(B(mid) $B:G=i$O%F%s%]!&%^%C%W$,=q$+$l$k(B */
#else
file *fp1;	/* $BF~NO%U%!%$%k(B(mml) */
file *fp2;	/* $B%F%s%]%^%C%W0J30$N(BSMF$B$r=q$-9~$`>l=j(B */
file *fp3;	/* $B=PNO%U%!%$%k(B(mid) $B:G=i$O%F%s%]!&%^%C%W$,=q$+$l$k(B */
#endif
char outfile[128]; /* $B=PNO%U%!%$%kL>(B($BJQ49<:GT;~$N%U%!%$%k:o=|MQ(B) */
int timebase;           /* $B%?%$%`%Y!<%9(B 48,60,80,96,120,160,240,480 */
fpos_t trkno;           /* $B%H%i%C%/?t$r=q$-9~$`>l=j(B */
int trknum;             /* $B%H%i%C%/?t(B */
fpos_t trksize;         /* $B%H%i%C%/%5%$%:$r=q$-9~$`>l=j(B */
fpos_t trkend;          /* $B%H%i%C%/$N=*N;0LCV(B */
fpos_t tposize;         /* $B%F%s%]%H%i%C%/$N%H%i%C%/%5%$%:$r=q$-9~$`>l=j(B */
char title[MAXTITLESTR]; /* $B6J$N%?%$%H%k(B */
fpos_t lastlenpos;       /* $B:G8e$K2;D9$r=q$-9~$s$@>l=j$X$N%]%$%s%?(B */
long lastlen;            /* $B:G8e$K=q$-9~$s$@2;D9$NCM(B */
int tnum; /* $B%Q!<%HL>!%(B  $B%H%i%C%/$rI=$9(B 0A 1B 2C $B$J$I$N(B 0,1,2 */
int talf; /* $B%H%i%C%/L>!%%H%i%C%/$rI=$9(B 0A 1B 2C $B$J$I$N(B A,B,C */
int trans = 0; /* $B%*%W%7%g%s%9%$%C%A(BT$B$K$h$kE>D4CM(B */
int x68k = 0; /* <, > $B$r5U$K$9$k%9%$%C%A(B */
long master_step[1024];	/* MKR$BDI2C(B */
char master_ch[1024];	/* MKR$BDI2C(B */
int master_count;		/* MKR$BDI2C(B */
char track_map[320];	/* MKR$BDI2C(B */
long master_step_temp;
int head;             /* $B=>B0%Q!<%H$G%X%C%@$r=q$$$?$+$I$&$+$N%U%i%0(B */

#ifndef WINDOWS
void sw(void);
#endif

void remove_file(void);
void owari(void);
int META_event(int x);

#ifdef BCC
void smfheader(long fp, int i); /* SMF$B$N%X%C%@$r=PNO$9$k(B */
void smftrkheader(long fp, fpos_t *trsize); /* SMF$B%H%i%C%/%X%C%@=PNO(B */
void smftrkend(long fp, fpos_t *trsize); /* SMF$B%H%i%C%/=*N;%$%Y%s%H=PNO(B */
extern void write_length(long i, long fp);
#else
void smfheader(file *fp, int i); /* SMF$B$N%X%C%@$r=PNO$9$k(B */
void smftrkheader(file *fp, fpos_t *trsize); /* SMF$B%H%i%C%/%X%C%@=PNO(B */
void smftrkend(file *fp, fpos_t *trsize); /* SMF$B%H%i%C%/=*N;%$%Y%s%H=PNO(B */
extern void write_length(long i, file *fp);
#endif
void puttitle(void);
void analyze(void);
void getsp(void); /* #$B%3%^%s%I$N<hF@(B */
void gettitle(void);
int getspn(void);

#ifdef BCC
long fp4;
#else
file *fp4;
#endif
int rstatus[64];
fpos_t trktop[64];
int fmat = 1;

void format1to0(void);
int get1(int i);
long getlength(int x);
void MIDI_event(int x, int code);
void write_code(int x);

#ifndef WINDOWS
int main( int argc,char *argv[] )
{
    int i;
    int ar;
    char *l;
    char file1[128];
    
    if(setjmp(env)) return 1;
    printf("MML->MID Compiler Ver5.07  By A.Monden & MKR\n");
    
    /* option switch handling -------- >>>>>>>>>> */
    if( argc<2 ) sw();
    if(argc==2 || *argv[2] == '/' || *argv[2] == '-' ||
    	strlen(argv[2]) <= 2 ) ar=2;
    else ar=3;
    for(;ar<argc;ar++){
    	i = 0;
        if(argv[ar][0]=='/' || argv[ar][0]=='-') i = 1;
        if(argv[ar][i]=='f' || argv[ar][i]=='F'){
        	fmat = 0;
        }else if(argv[ar][i]=='t' || argv[ar][i]=='T'){
            trans = atoi(argv[ar]+2);
        }else if(argv[ar][i]=='x' || argv[ar][i]=='X'){
            x68k = 1;
        }else if(argv[ar][i]=='o' || argv[ar][i]=='O'){
        	printf("option switch 'O' is obsolete. Ignored.\n");
            continue;
        }else if(argv[ar][i]=='n' || argv[ar][i]=='N'){
        	printf("option switch 'N' is obsolete. Ignored.\n");
            continue;
        }else{
            printf("ERROR! unknown switch '%c'\n",argv[ar][i]);
            sw();
        }
    }
    /* <<<<<<<<< -------- option switch handling */
    
#ifdef _fmode
    _fmode = O_BINARY; /* for BCC $B%0%m!<%P%kJQ?t(B _fmode $B$KCM$rBeF~(B */
#endif
    
    /* mml file open -------- >>>>>>>>>> */
    if(strchr(argv[1],'.')==NULL){
        strcpy(file1,argv[1]);
        strcat(file1,".mml");
        if((fp1 = fopen2(file1, "rb")) == NULL){
            printf("ERROR! Unable to open %s\n",argv[1]);
            owari();
        }
    }else if((fp1 = fopen2(argv[1], "rb")) == NULL){
        printf("ERROR! Unable to open %s\n",argv[1]);
        owari();
    }
    /* <<<<<<<<< -------- mml file open */
    
    /* mid file open -------- >>>>>>>>>> */
    if(argc==2 || argv[2][0] == '/' || argv[2][0] == '-' ||
    	strlen(argv[2]) <= 2 ){
        if(strchr(argv[1],'.')==NULL){
            strcpy(outfile,argv[1]);
            strcat(outfile,".mid");
            if((fp3 = fopen2(outfile, "wb")) == NULL){
                printf("ERROR! Unable to open %s\n",outfile);
                fclose2(fp1);
                owari();
            }
        }else{
            strcpy(outfile,argv[1]);
            l=(char *)strchr(outfile,'.');
            while(strchr(l+1,'.') != NULL){ /* path $BL>$KJ#?t(B"."$B$,(B */
                l=(char *)strchr(l+1,'.');  /* $B$"$k>l9g$N=hM}(B */
            }
            *l='\0';
            strcat(outfile,".mid");
            if((fp3 = fopen2(outfile, "wb")) == NULL ){
                printf("ERROR! Unable to open %s\n",outfile);
                fclose2(fp1);
                owari();
            }
        }
    }else{
        if((fp3 = fopen2(argv[2], "wb")) == NULL ){
            printf("ERROR! Unable tp open %s\n",argv[2]);
            fclose2(fp1);
            owari();
        }
        strcpy(outfile,argv[2]);
    }
    /* <<<<<<<<< -------- mid file open */
    
    analyze();
    InvalidateRect(hWnd3,NULL,TRUE);
    UpdateWindow(hWnd3);
    fclose2(fp1);
    return 0; /* $B@5>o=*N;(B */
}
#endif

#ifdef WINDOWS
/* . */
/* file1 $B$O(B $BF~NO(B mml $B%U%!%$%k$NL>A0(B */
/* file2 $B$O(B $B=PNO(B mid $B%U%!%$%k$NL>A0(B */
/* file2[0] == '\0' $B$J$i$P!$=PNO%U%!%$%kL>$r<+F0@8@.$9$k(B */
/* $B<+F0@8@.$NNc(B foo.mml $B$,F~NO$J$i$P(B foo.mid  $B$r=PNO%U%!%$%k$H$9$k(B */
/* . */
int mml2mid(char *file1, char *file2)
{
    int i;
    char *l;
    if(setjmp(env)){
        return 1; /* longjmp $B$+$iLa$C$?$H$-<B9T$5$l$k(B */
    }
    wsprintf(Msg, "MML->MID Compiler Ver5.07  By A.Monden & MKR\n\n");
    strcat(text,Msg);
    InvalidateRect(hWnd3,NULL,TRUE);
    UpdateWindow(hWnd3);
    
    /* mml file open -------- >>>>>>>>>> */
    if((fp1 = fopen2(file1, "rb")) == NULL){
        wsprintf(Msg,"ERROR! File open error '%s'\n",file1);
        strcat(text,Msg);
        owari();
    }
    /* <<<<<<<<<< -------- mml file open */
    
    /* mid file open -------- >>>>>>>>>> */
    if(file2[0] == '\0'){
        strcpy(outfile,file1);
        l=(char *)strchr(outfile,'.');
        while(strchr(l+1,'.') != NULL){ /* path $BL>$KJ#?t(B"."$B$,(B */
            l=(char *)strchr(l+1,'.');  /* $B$"$k>l9g$N=hM}(B */
        }
        *l='\0';
        strcat(outfile,".mid");
    }else{
        strcpy(outfile, file2);
    }
    if((fp3 = fopen2(outfile, "wb")) == NULL ){
        wsprintf(Msg,"ERROR! File open error '%s'\n",outfile);
        strcat(text,Msg);
        fclose2(fp1);
        owari();
    }
    /* <<<<<<<<<< -------- mid file open */
    
    analyze();
    InvalidateRect(hWnd3,NULL,TRUE);
    UpdateWindow(hWnd3);
    fclose2(fp1);
    return 0; /* $B@5>o=*N;(B */
}
#endif

#ifndef WINDOWS
void sw(void)   /* Usage */
{
    printf("\nmml2mid filename[.mml] (filename[.mid]) (switches)\n");
    printf("  (switches) -F  : Output format 0 file\n");
	printf("             -Tn : Transepose (-24 < n < 24)\n");
	printf("             -X  : Exchange >,<\n");
    owari();
}
#endif /* WINDOWS */

/* $B$9$Y$F$N%U%!%$%k$r%*!<%W%s$7$?8e$G!$%(%i!<$,=P$?>l9g$K!$(B
   $B$3$N4X?t$,8F$P$l$k!%(B
   $B$3$N4X?t$O!$(Bmmlproc.c$B$N(Berr()$B$J$I$+$i8F$P$l$k!%(B */
void remove_file(void)
{
    fclose2(fp1);
    ffree(fp2);
    freemacro();
    fclose2(fp3);
    remove(outfile);
    owari();
}

void owari(void)
{
    InvalidateRect(hWnd3,NULL,FALSE);
    UpdateWindow(hWnd3);
    longjmp(env,1);
}

#ifdef BCC
void smfheader(long fp, int i) /* SMF$B$N%X%C%@$r=PNO$9$k(B */
#else
void smfheader(file *fp, int i) /* SMF$B$N%X%C%@$r=PNO$9$k(B */
#endif
{
    putc2('M', fp); /* SMF Header */
    putc2('T', fp);
    putc2('h', fp);
    putc2('d', fp);
    putc2(0, fp);   /* header length */
    putc2(0, fp);
    putc2(0, fp);
    putc2(6, fp);
    putc2(0, fp);
    putc2(i, fp);   /* format 0 or 1 */
    putc2(0, fp);
    fgetpos2(fp, &trkno);
    putc2(1, fp);  /* $B%H%i%C%/?t(B($B:G=i$O(B1$B$r=q$$$F$*$/(B) */
    putc2((char)(timebase / 256), fp); /* timebase */
    putc2((char)(timebase % 256), fp);
}

/* SMF$B$N3F%H%i%C%/$N%X%C%@$r=PNO$9$k(B */
#ifdef BCC
void smftrkheader(long fp, fpos_t *trsize)
#else
void smftrkheader(file *fp, fpos_t *trsize)
#endif
{
    putc2('M', fp); /* Track Header */
    putc2('T', fp);
    putc2('r', fp);
    putc2('k', fp);
    fgetpos2(fp, trsize);
    fseek2(fp, 4, SEEK_CUR); /* $B%H%i%C%/%5%$%:$r=q$-9~$`>l=j(B */
    fgetpos2(fp, &lastlenpos);
    lastlen = 0;
    putc2(0, fp); /* $B:G=i$N%9%F%C%W%?%$%`(B */
}

/* SMF$B$N3F%H%i%C%/$N=*N;%$%Y%s%H$r=PNO$9$k(B */
#ifdef BCC
void smftrkend(long fp, fpos_t *trsize)
#else
void smftrkend(file *fp, fpos_t *trsize)
#endif
{
    long j, j2;
    long i1, i2, i3, i4;
    putc2(0xff, fp);
    putc2(0x2f, fp);
    putc2(0, fp);
    fgetpos2(fp, &trkend);
    j = (long)trkend - (long)(*trsize) - 4; /* $B$?$V$s(B -4 $B$G$$$$$H;W$&(B */
    fsetpos2(fp, trsize);
    j2 = j / 65536;
    j %= 65536;
    i4 = j2 / 256;
    i3 = j2 % 256;
    i2 = j / 256;
    i1 = j % 256;
    putc2(i4, fp); /* $B=jDj$N0LCV$K%H%i%C%/%5%$%:$r=q$-9~$`(B */
    putc2(i3, fp);
    putc2(i2, fp);
    putc2(i1, fp);
    fsetpos2(fp,&trkend);
}

void puttitle(void)
{
    int i;
    putc2(0xff, fp3);
    putc2(3, fp3);
    putc2(strlen(title), fp3);
    for(i = 0; i < strlen(title); i++){
	putc2(title[i], fp3);
    }
}

/*
  mml$B$r(Bmid$B$KJQ49$9$k!%(B
  $B%U%!%$%k$N<h$j07$$!$(BSMF$B%X%C%@$N=PNO!$$J$I$r<g$K9T$&!%(B
  
  fp2$B$KIaDL$N%H%i%C%/$N%G!<%?$r=q$-!"(Bfp3$B$K%F%s%]%^%C%W$r=q$/!#(B
  $B8e$G!"(Bfp3$B$N8e$m$K(Bfp2$B$r$/$C$D$1$k(B(close3()$B$,9T$J$&(B)$B!%(B
  fp2$B$O!$(Bfmalloc()$B$G%a%b%j$@$13NJ]$5$l$k(B($B%U%!%$%k$O%*!<%W%s$5$l$J$$!%(B)
  $B$J$*!$(Bfp2$B$O%U%!%$%k$O%*!<%W%s$5$l$F$J$$$b$N$N!$(Bfgetc2,fputc2$B$J$I$,(B
  fp1,fp3$B$HF1MM$K;H$($k!%(Bfp2$B$O!$(Bffree(fp2)$B$H$d$C$F!$<+J,$G%a%b%j$r2rJ|(B
  $B$7$J$$$H$$$1$J$$!%(B
  */
void analyze(void)
{
    int i;
    timebase = 48;		/* $B%?%$%`%Y!<%9=i4|CM(B */
    trknum = 0;			/* $B%H%i%C%/?t(B */
    
    if((fp2 = fmalloc()) == NULL ){
        wsprintf(Msg,"ERROR! Cannot allocate memory (for fp2)\n");
        strcat(text,Msg);
        fclose2(fp1);
        fclose2(fp3);
        owari();
    }
    title[0] = NULL;
    getsp();			/* #$B%3%^%s%I$N<hF@(B */
    smfheader(fp3, 1);		/* SMF$B$N%X%C%@$r=PNO$9$k(B */
	
    fseek2(fp1, 0, SEEK_SET);	/* $B%U%!%$%k$N@hF,$K0\F0(B */
    initmacro();		/* $B%^%/%m$N=i4|2=(B */
    getmacro();			/* $B$^$:!"%^%/%m$r<hF@$7$F$*$/(B */
    smftrkheader(fp3, &tposize); /* $B%F%s%]%^%C%W$N%X%C%@=PNO(B */
    puttitle();			/* $B%?%$%H%k=PNO!%:G8e$K%9%F%C%W%?%$%`$r=q$-9~$^$J$$(B */
    trktop[0] = tposize + 4;	/* $B%F%s%]%^%C%W$N%X%C%@$ND>8e$N0LCV(B */
    
    for(i = 0; i < 320; i++) track_map[i]=0;
	
    for(talf = 0; talf < 26; talf++){
        if (talf>0 && track_map[talf]==0 && track_map[26]==0) continue;
        master_count=0;
    	tnum=0; /* $B<g%H%i%C%/(B0[A$B!A(BZ]$B$r$^$:%A%'%C%/$9$k(B */
    	for (i=0;i<512;i++) {
	    master_step[i]=-1;
	    master_ch[i]=-1;
    	}
    	fseek2(fp1, 0, SEEK_SET); /* $B%U%!%$%k$N@hF,$K0\F0(B */
	head = 0;		/* $B=>B0%H%i%C%/$G$^$@%X%C%@$r=q$$$F$$$J$$(B */
	master_step_temp=-1;
	if(converttrk() != -1){ /* $B<g%H%i%C%/(B0[A$B!A(BZ]$B$,B8:_$9$k>l9g(B */
	    smftrkend(fp2, &trksize); /* $B%H%i%C%/$N=*N;%$%Y%s%H=PNO(B */
	    trktop[trknum] = trksize + 4; /* $B%X%C%@$ND>8e$N0LCV(B */
	    for (tnum=1;tnum < 10 ; tnum++) {
		if(track_map[tnum*32+talf]==0 && track_map[tnum*32+26]==0) continue; /* $B=>B0%H%i%C%/$,B8:_$7$J$$(B */
		master_count=-1;
		fseek2(fp1, 0, SEEK_SET); /* $B%U%!%$%k$N@hF,$K0\F0(B */
		head = 0;	/* $B=>B0%H%i%C%/$G$^$@%X%C%@$r=q$$$F$$$J$$(B */
		if(converttrk() != -1){
		    smftrkend(fp2, &trksize); /* $B%H%i%C%/$N=*N;%$%Y%s%H=PNO(B */
		    trktop[trknum] = trksize + 4; /* $B%X%C%@$ND>8e$N0LCV(B */
		}
	    }
    	}
    }
	
    write_tmap();
    smftrkend(fp3, &tposize);	/* $B%F%s%]%H%i%C%/$N=*N;%$%Y%s%H=PNO(B */
    fsetpos2(fp3, &trkno);	/* $B%H%i%C%/?t$r=q$-9~$`>l=j$K0\F0$9$k(B */
    trknum++;			/* $B%H%i%C%/?t$K%F%s%]%^%C%W$NJ,$rB-$9(B */
    putc2(trknum, fp3);		/* $B%H%i%C%/?t$r=q$-9~$`(B */
    /* fseek2(fp3, 2, SEEK_CUR); */ /* $B%?%$%`%Y!<%9$NJ,$r%9%-%C%W$9$k(B */
    if(fmat == 0){
    	format1to0();
    	fclose4(fp3, fp4);	/* fp3$B$N>l=j$K(Bfp4$B$r=q$/!#(Bfp3$B$r%/%m!<%:(B */
    	ffree(fp4);		/* fp4$B$N%a%b%j$r3+J|$9$k(B */
    }else{
	fclose3(fp3, fp2);	/* fp3$B$N8e$K(Bfp2$B$r$/$C$D$1$k!#(Bfp3$B$r%/%m!<%:(B */
    }
    ffree(fp2);			/* fp2$B$N%a%b%j$r2rJ|$9$k!%(B */
    freemacro();		/* $B%^%/%mMQ%a%b%j$r3+J|$9$k(B */
}

void getsp(void)
{
    int code;
    int i1, i2, i3;
    for(;;){
	code = getc2(fp1);
	if(code == EOF) break;
	if(code != '#') continue;
	i1 = getc2(fp1);
	i2 = getc2(fp1);
	i3 = getc2(fp1);
	if(i1 == 't' && i2 == 'i' && i3 == 't') gettitle();
	else if(i1 == 't' && i2 == 'i' && i3 == 'm') timebase = getspn();
	else fseek2(fp1, -3, SEEK_CUR);
    }
}

void gettitle(void)
{
    int code, i;
    for(;;){
	code = getc2(fp1);
	if(code == EOF) break;
	if(code != '"') continue;
	for(i = 0; i < MAXTITLESTR; i++){
	    code = getc2(fp1);
	    if(code == '"' || code == '\n' || code == EOF) break;
	    title[i] = code;
	}
	title[i] = NULL;
	break;
    }
}

int getspn(void)
{
    int code, i = 0;
    for(;;){
	code = getc2(fp1);
	if(code == EOF) return -1;
	if(code == ' ' || code == '\t') break;
    }
    for(;;){
	code = getc2(fp1);
	if(code < '0' || '9' < code) break;
	i = i * 10 + code - '0';
    }
    fseek2(fp1, -1, SEEK_CUR);
    return i;
}

void format1to0(void)
{
	int i;
	int tr; /* $B8=:_JQ49Cf$N%H%i%C%/(B */
	long ctrk[64]; /* $B3F%H%i%C%/$N=hM}Cf$N%$%Y%s%H$N%9%F%C%W%?%$%`(B */
	int endsw[64];
	long j; /* $BHFMQ(B */
	int code;
	int hend = 0; /* $BJQ49:Q$_%H%i%C%/$N8D?t(B */
	long plus = 0;
	
    if((fp4 = fmalloc()) == NULL ){
        wsprintf(Msg,"ERROR! Cannot allocate memory (for fp4)\n");
        strcat(text,Msg);
        fclose2(fp1);
        fclose2(fp3);
        ffree(fp2);
        owari();
    }
	
	smfheader(fp4, 0);
	smftrkheader(fp4, &trksize);
    fsetpos2(fp4, &lastlenpos);
	
	for(i = 0; i < trknum; i++){
		if(i == 0 ){
			fsetpos2(fp3, &trktop[0]);
		}else{
			fsetpos2(fp2, &trktop[i]);
		}
		ctrk[i] = getlength(i); /* $B=hM}Cf$N%$%Y%s%H$N%9%F%C%W%?%$%`(B */
		if(i == 0 ){
			fgetpos2(fp3, &trktop[0]);
		}else{
			fgetpos2(fp2, &trktop[i]);
		}
		/*printf("length[%d] = %ld\n", i, ctrk[i]);*/
		endsw[i] = 0; /* $BJQ49$,=*N;$7$?$+$I$&$+(B */
		rstatus[i] = 0; /* $B%i%s%K%s%0%9%F!<%?%9(B */
	}
	
	for(;;){
		tr = 0;
		j = 99999999;
		for(i = 0; i < trknum; i++){
			if(endsw[i] != 0) continue;
			if(ctrk[i] < j){
				j = ctrk[i];
				tr = i;
			}
		}
		if(tr == 0 ){
			fsetpos2(fp3, &trktop[0]);
		}else{
			fsetpos2(fp2, &trktop[tr]);
		}
		/*printf("%ld(%d)", ctrk[tr], tr);*/
		write_length(ctrk[tr] + plus, fp4);
		plus = 0;
		for(i = 0; i < trknum; i++){
			if(endsw[i] == 0 && i != tr) ctrk[i] -= ctrk[tr];
		}
		code = get1(tr);
		/*printf("[%x]", code);*/
		
		if(code == EOF){
		    printf("error occured while converting format 1 -> 0.\n");
		    printf("There's no track_end event.\n");
		    exit(1);
		}else if(code < 0xf0){
			MIDI_event(tr, code);
		}else if(code == 0xf0 || code == 0xf7){
			putc2(code, fp4);
		    write_code(tr);
		}else if(code == 0xff){
		    if(META_event(tr) == -1){
		    	/*printf("end\n");*/
		    	plus = lastlen;
		    	fsetpos2(fp4, &lastlenpos); /* $B8HB)$J<jCJ(B */
		    	if(++hend == trknum) break;
		    	endsw[tr] = 1;
		    	continue;
		    }
		}else{
		    printf("error occured while converting format 1 -> 0.\n");
		    printf("abnormal code '%x'\n",code);
		    exit(1);
		}
		ctrk[tr] = getlength(tr);
		/*printf("new get length for %d = %ld\n", tr, ctrk[tr]);*/
		if(tr == 0 ){
			fgetpos2(fp3, &trktop[0]);
		}else{
			fgetpos2(fp2, &trktop[tr]);
		}
	}
	putc2(0, fp4);
	smftrkend(fp4, &trksize);
}

void MIDI_event(int x, int code)
{
    int i;
	
    if(code < 0x80){
    	putc2(rstatus[x], fp4);
    }else{
    	rstatus[x] = code;
    	putc2(rstatus[x], fp4);
    	code = get1(x);
    }
	putc2(code, fp4);
	/*printf("<%x>",code);*/
	
	if(rstatus[x] / 16 == 8 || rstatus[x] / 16 == 9 ||
				rstatus[x] / 16 == 10 || rstatus[x] / 16 == 11 ||
				rstatus[x] /16 == 14){
	    putc2(get1(x), fp4);
	}
}

int META_event(int x)
{
    int code;
    code = get1(x);
    if(code == 0x2f){ /* track end */
		code = get1(x);
		if(code != 0){
		    printf("error occured while converting format 1 -> 0.\n");
		    printf("abnormal code 'FF 2F %X'\n",code);
		    exit(1);
		}
		return -1;
   	}
	putc2(0xff, fp4);
	putc2(code, fp4);
	write_code(x);
	return 0;
}

void write_code(int x)
{
    int i;
    int length;
    length = get1(x);
    putc2(length, fp4);
    for(i = 0; i < length; i++) putc2(get1(x), fp4);
}

int get1(int i)
{
	if(i == 0){
		return getc2(fp3);
	}else{
		return getc2(fp2);
	}
}

long getlength(int x) /* get length from SMF */
{
    long i1, i2, i3, i4;
    long num;
    long j = 0x80;
    i1 = get1(x);
    if(i1 >= j){
		i2 = get1(x);
		if(i2 >= j){
		    i3 = get1(x);
		    if(i3 >= j){
				i4 = get1(x);
				num= (i1 - j) * j * j * j + (i2 - j) *
				    j * j + (i3 - j) * j + i4;
		    }else num = (i1 - j) * j * j + (i2 - j) *
    		    j + i3;
		}else num = (i1 - j) * j + i2;
    }else num = i1;
    return num;
}

